DATA SEGMENT
    ROW_VALUE DB 0        ; 洢ֵ(0-3)
    COL_VALUE DB 0        ; 洢ֵ(0-3)
    KEY_VALUE DB 0        ; ռֵ
    ; չ0-9ͷ
    SEG_TABLE DB 3FH,06H,5BH,4FH,66H,6DH,7DH,07H,7FH,6FH  ; 0-9Ķ
              DB 77H,40H,76H,3FH,73H,50H                   ; A(+),B(-),C(*),D(/),E(=),F(C)Ķ
    DISP_BUF DB 4 DUP(0) ; ʾ
    POS DB 0             ; ǰɨλ
    NUM1 DW 0            ; һ
    NUM2 DW 0            ; ڶ
    OP DB 0              ; (0:, 1:+, 2:-, 3:*, 4:/)
    STATE DB 0           ; ״̬(0:һ, 1:ڶ)
    TEMP DW 0            ; ʱ
DATA ENDS

CODE SEGMENT
    ASSUME CS:CODE, DS:DATA
    
START:
    MOV AX, DATA
    MOV DS, AX
    
    ; 8255ʼ: PA(ɨ),PB(),PC4λ()4λ(λѡ)
    MOV DX, 213H         ; ƶ˿ڵַ
    MOV AL, 10000001B    ; PAʽ0, PBʽ0, PC4λ4λ
    OUT DX, AL
    
    ; ʼPAڣΪߵƽ
    MOV DX, 210H
    MOV AL, 0FH          ; PA0-PA31111
    OUT DX, AL
    
    ; ʼPC4λر
    MOV DX, 212H
    MOV AL, 0F0H         ; PC4-PC71111
    OUT DX, AL

MAIN_SCAN:
    CALL DISPLAY_SCAN    ; ʾɨӳ
    
    ; ȡPCڼǷа
    MOV DX, 212H         
    IN AL, DX
    AND AL, 0FH          ; ֻȡ4λ
    CMP AL, 0FH          ; ȽǷȫΪ1
    JZ MAIN_SCAN         ; ȫ1˵ްɨ
    
    ; а£
    CALL DELAY_SHORT
    
    ; ٴȷϰ
    IN AL, DX
    AND AL, 0FH
    CMP AL, 0FH
    JZ MAIN_SCAN         ; Ƕѭ
    
    ; ȷа浱ǰֵ
    MOV BL, AL           ; ֵ
    
    ; ͨƺTESTָȷк
    MOV CL, 0            ; м
    MOV AL, BL           ; ֵڲ
COL_CHECK:
    TEST AL, 01H         ; λ
    JZ COL_FOUND         ; Ϊ0ҵк
    INC CL               ; кż1
    SHR AL, 1           ; һλ
    JMP COL_CHECK
    
COL_FOUND:
    MOV COL_VALUE, CL    ; к
    
    ; ʼɨ裬ӵһпʼ
    MOV CL, 3            ; м
    MOV BL, 11110111B    ; һɨ1110B
    
ROW_SCAN:
    MOV DX, 210H         ; PAڵַ
    MOV AL, BL
    OUT DX, AL           ; ɨź
    
    MOV DX, 212H         ; PCڵַ
    IN AL, DX
    AND AL, 0FH          ; ֻȡ4λ
    CMP AL, 0FH          ; ǷжΪ
    JZ ROW_FOUND        ; ҵ
    
    ROR BL, 1            ; ѭƲһɨ
    DEC CL               ; кż1
    CMP CL, 0FFH         ; Ƿɨ4
    JNZ ROW_SCAN         ; δɼɨ
    JMP MAIN_SCAN        ; ɨ裬ѭ

ROW_FOUND:
    MOV ROW_VALUE, CL    ; к
    
    ; ռֵ
    CALL CALC_KEY_VALUE
    
    ; ʾ
    CALL UPDATE_DISPLAY
    
    ; ָΪ
    MOV DX, 210H
    MOV AL, 0FH
    OUT DX, AL
    
    ; ӳʱֹظ
    CALL DELAY_LONG
    
    JMP MAIN_SCAN        ; ɨѭ

; ʱӳ
DELAY_SHORT PROC
    PUSH CX
    MOV CX, 1000
DELAY_SHORT_LOOP:
    LOOP DELAY_SHORT_LOOP
    POP CX
    RET
DELAY_SHORT ENDP

; ʱӳԼ1룩
DELAY_LONG PROC
    PUSH CX
    PUSH DX
    
    MOV CX, 07H          ; ѭ
DELAY_LONG_OUTER:
    PUSH CX
    MOV CX, 02222H       ; ѭ
DELAY_LONG_INNER:
    LOOP DELAY_LONG_INNER
    POP CX
    LOOP DELAY_LONG_OUTER
    
    POP DX
    POP CX
    RET
DELAY_LONG ENDP

; ֵӳ
CALC_KEY_VALUE PROC
    PUSH AX
    
    MOV AL, ROW_VALUE    ; ȡк
    MOV CL, 4
    MUL CL              ; кų4
    ADD AL, COL_VALUE    ; кŵõ0-15ļֵ
    MOV KEY_VALUE, AL    ; ֵ
    
    POP AX
    RET
CALC_KEY_VALUE ENDP

; ʾӳ
UPDATE_DISPLAY PROC
    PUSH AX
    PUSH BX
    PUSH CX
    
    MOV AL, KEY_VALUE
    CMP AL, 0AH          ; Ƿ
    JAE HANDLE_OPERATOR
    
    ; 
    CMP STATE, 0
    JE FIRST_NUM
    JMP SECOND_NUM
    
HANDLE_OPERATOR:
    CMP AL, 0EH          ; ǷǵȺ(E)
    JE CALC_RESULT
    CMP AL, 0FH          ; Ƿ(F)
    JE CLEAR_ALL
    
    ; 
    SUB AL, 0AH          ; תΪ1-4Ĳ
    MOV OP, AL
    MOV STATE, 1         ; лڶ
    JMP UPDATE_END
    
FIRST_NUM:
    ; NUM1
    MOV AX, NUM1
    MOV BX, 10
    MUL BX
    ADD AL, KEY_VALUE
    MOV NUM1, AX
    ; ʾNUM1
    CALL DISPLAY_NUMBER
    JMP UPDATE_END
    
SECOND_NUM:
    ; NUM2
    MOV AX, NUM2
    MOV BX, 10
    MUL BX
    ADD AL, KEY_VALUE
    MOV NUM2, AX
    ; ʾNUM2
    CALL DISPLAY_NUMBER
    JMP UPDATE_END
    
CALC_RESULT:
    CALL CALCULATE
    JMP UPDATE_END
    
CLEAR_ALL:
    MOV NUM1, 0
    MOV NUM2, 0
    MOV OP, 0
    MOV STATE, 0
    MOV DISP_BUF[0], 0
    MOV DISP_BUF[1], 0
    MOV DISP_BUF[2], 0
    MOV DISP_BUF[3], 0
    
UPDATE_END:
    POP CX
    POP BX
    POP AX
    RET
UPDATE_DISPLAY ENDP
; ӳ
CALCULATE PROC
    PUSH AX
    PUSH BX
    PUSH DX

    MOV AX, NUM1
    MOV BX, NUM2

    CMP OP, 0
    JE DO_ADD
    CMP OP, 1
    JE DO_SUB
    CMP OP, 2
    JE DO_MUL
    CMP OP, 3
    JE DO_DIV
    JMP CALC_END

DO_ADD:
    ADD AX, BX
    JMP SAVE_RESULT
DO_SUB:
    SUB AX, BX
    JMP SAVE_RESULT
DO_MUL:
    MUL BX
    JMP SAVE_RESULT
DO_DIV:
    CMP BX, 0
    JE CALC_END          ; 0
    MOV DX, 0
    DIV BX

SAVE_RESULT:
    MOV NUM1, AX         ; NUM1Ա
    MOV NUM2, 0
    MOV OP, 0
    MOV STATE, 0
    CALL DISPLAY_NUMBER  ; ʾ

CALC_END:
    POP DX
    POP BX
    POP AX
    RET
CALCULATE ENDP


; ʾӳ
DISPLAY_NUMBER PROC
    PUSH AX
    PUSH BX
    PUSH CX
    PUSH DX

    ; ״̬ѡҪʾ
    CMP STATE, 0
    JE SHOW_NUM1
    JMP SHOW_NUM2

SHOW_NUM1:
    MOV AX, NUM1
    JMP DO_CONVERT

SHOW_NUM2:
    MOV AX, NUM2
    JMP DO_CONVERT

DO_CONVERT:
    ; ʾ
    MOV DISP_BUF[0], 0
    MOV DISP_BUF[1], 0
    MOV DISP_BUF[2], 0
    MOV DISP_BUF[3], 0

    ; תֵBCD벢ʾ
    MOV CX, 4           ; ʾ4λ
    MOV BX, 0           ; ұ߿ʼʾ

CONVERT_LOOP:
    MOV DX, 0
    PUSH BX             ; BX
    MOV BX, 10
    DIV BX              ; AX10AXУDX
    POP BX
    
    ; ʾ
    MOV DISP_BUF[BX], DL
    
    INC BX
    LOOP CONVERT_LOOP

DISPLAY_END:
    POP DX
    POP CX
    POP BX
    POP AX
    RET
DISPLAY_NUMBER ENDP
; ʾɨӳ
DISPLAY_SCAN PROC
    PUSH AX
    PUSH BX
    PUSH DX
    
    ; ȡǰλʾ
    MOV BL, POS
    MOV BH, 0
    MOV AL, DISP_BUF[BX]  ; ȡҪʾ
    
    ; תΪ
    MOV BX, OFFSET SEG_TABLE
    XLAT                   ; ALеתΪӦĶ
                     ; ȡʹλЧ
    PUSH AX               ; 
    
    ; λѡźţλЧ
    MOV AL, 00010000B          ; 0111 1111B  ʼֵΪ07FH
    MOV CL, POS
ROTATE:
    CMP CL, 0
    JZ POSITION_READY
    ROL AL, 1             ; ѭλѡ루Ϊƣ
    DEC CL
    JMP ROTATE
    
POSITION_READY:
    MOV DX, 212H          ; PCڵַ
    OUT DX, AL            ; λѡź
    
    ; 
    POP AX                ; ָ
    MOV DX, 211H          ; PBڵַ
    OUT DX, AL            ; 
    
    ; λü
    INC POS
    CMP POS, 4
    JNZ SCAN_END
    MOV POS, 0
    
SCAN_END:
    POP DX
    POP BX
    POP AX
    RET
DISPLAY_SCAN ENDP


CODE ENDS
END START